Summary:	a system for algebraic geometry and commutative algebra	
Name:   	Macaulay2 
Version:	0.9.2
Release: 	8.PU_IAS.4
Copyright: 	GPL 
Group:  	Applications/Engineering
Source0:	http://www.math.uiuc.edu/Macaulay2/ftp-site/%{name}-%{version}-src.tar.gz
Patch0: 	%{name}-0.9-optimize.patch
Patch1:		%{name}-0.9-encap.patch
Patch2:		%{name}-0.9-htmlview.patch
Patch3:		%{name}-0.9-static.patch
Patch4:		Macaulay2-0.9.2-c++-fix.patch
Patch5:		Macaulay2-0.9.2-fixlibdir.patch
Patch6:		Macaulay2-0.9.2-cppfixes.patch
URL: 		http://www.math.uiuc.edu/Macaulay2/
Prefix:		%{_prefix}
BuildRoot:	%{_tmppath}/%{name}-%{version}-%(id -u -n)-root
Requires:   	gc >= 6.1, gmp >= 4.0
BuildRequires:	gc-devel >= 6.1
BuildRequires:	factory >= 1.3b-4, libfac >= 0.3.2-4
BuildRequires:	gdbm-devel >= 1.8.0, gmp-devel >= 4.0.1
Provides:	Macaulay2-emacs
Obsoletes:	Macaulay2-emacs

%{!?_applnkdir:%define _applnkdir %{_sysconfdir}/X11/applnk}
%{!?_icondir:%define _icondir %{_datadir}/pixmaps}

%description
Macaulay 2 is a new software system devoted to supporting research in 
algebraic geometry and commutative algebra written by Daniel R. Grayson 
and Michael E. Stillman

%package doc 
Group: Documentation 
Requires: %{name} = %{version}-%{release}
Requires: htmlview
Summary: Macaulay2 documentation 
%description doc
Macaulay2 documentation. 

%prep
%__rm -rf "$RPM_BUILD_ROOT"

%setup -q

%patch0 -p1 -b .opt
%patch1 -p1 -b .encap
%patch2 -p1 -b .htmlview
%patch3 -p1
%patch4 -p1
%patch5 -p1 -b .fixlibdir
%patch6 -p1 -b .cppfixes

%build
export CPPFLAGS="-I/usr/include/gc $RPM_OPT_FLAGS" CFLAGS="-I/usr/include/gc $RPM_OPT_FLAGS" LDFLAGS="-L%{_libdir} -ldl"
%configure  \
	--disable-optimize	\
	--enable-gc-for-new	\
	--disable-dumpdata	\
	--disable-static	\	

CPPFLAGS=-I/usr/include/gc CFLAGS=-I/usr/include/gc %{__make} 
CPPFLAGS=-I/usr/include/gc CFLAGS=-I/usr/include/gc %{?_with_check:%{__make} check }

%install
%makeinstall

# grab emacs files
%__install -d	$RPM_BUILD_ROOT%{_datadir}/emacs/site-lisp
%__mv		$RPM_BUILD_ROOT%{_libdir}/%{name}-%{version}/emacs/*.el	\
		$RPM_BUILD_ROOT%{_datadir}/emacs/site-lisp/

# Grab basic docs
%{__install} Macaulay2/README	./README
%{__install} Macaulay2/CHANGES 	./CHANGES
%{__install} Macaulay2/COPYING 	./COPYING

# Fix location in shell wrapper (%post too for relocation?)
%__perl -pi -e"s,M2HOME=.*,M2HOME=%{_libdir}/%{name}-%{version}," \
	$RPM_BUILD_ROOT%{_bindir}/M2 
%__perl -pi -e"s,M2HOME=.*,M2HOME=%{_libdir}/%{name}-%{version}," \
	$RPM_BUILD_ROOT%{_bindir}/M2-help

# applnk
cat > %{name}.desktop <<EOF
[Desktop Entry]
Name=%{name}
Exec=M2
Icon=
MimeType=
SwallowTitle=%{name}
Terminal=true
TerminalOptions=-caption "%{name}"
Type=Application
EOF
#__install -D -m644 %{name}.desktop $RPM_BUILD_ROOT%{_applnkdir}/Applications/%{name}.desktop

#fix up the small problems with emacs
perl -pi -e "s|/var/tmp/.*/usr|/usr|" $RPM_BUILD_ROOT%{_datadir}/emacs/site-lisp/*

#make new rpm happy
rm -f $RPM_BUILD_ROOT%{_libdir}/%{name}-%{version}/{README,CHANGES,COPYING}

%clean
%__rm -rf "$RPM_BUILD_ROOT"


%files
%defattr(-,root,root)
%doc README CHANGES COPYING
%{_bindir}/M2
#{_applnkdir}/*/*
%dir %{_libdir}/%{name}-%{version}
%{_libdir}/%{name}-%{version}/cache
%{_libdir}/%{name}-%{version}/libexec
%{_libdir}/%{name}-%{version}/m2
%{_libdir}/%{name}-%{version}/packages
%{_libdir}/%{name}-%{version}/setup
%{_datadir}/emacs/site-lisp/*
%doc %{_libdir}/%{name}-%{version}/emacs

%files doc
%defattr(-,root,root)
%{_bindir}/M2-help
%{_libdir}/%{name}-%{version}/html
%{_libdir}/%{name}-%{version}/tutorial


#%post
# Handle possible relocation...
#perl -pi -e"s,M2HOME=.*,M2HOME=%{_libdir}/%{name}-%{version}," %{_bindir}/M2
#exit 0

#%post doc
# Handle possible relocation...
#perl -pi -e"s,M2HOME=.*,M2HOME=%{_libdir}/%{name}-%{version}," %{_bindir}/M2-help
#exit 0

%preun
# Handle possibly existing dumpdata
%__rm -f %{_libdir}/%{name}-%{version}/libexec/Macaulay2-*-data
exit 0

#%postun


%changelog
* Tue Jul 05 2004 Josko Plazonic <plazonic@math.princeton.edu>
- introduced fixes to get it to compile on x86_64 platform
- NOTE that it may fail rebuild if home dir is on NFS, careful
  about locking...
- rebuilt for PU_IAS 1

* Fri May 02 2003 Josko Plazonic <plazonic@math.princeton.edu>
- rebuilt for RH 9

* Fri Jun 14 2002 Rex Dieter <rdieter@unl.edu> 0.9-7
- Provides/Obsoletes: Macaulay-emacs
- 'make check' if rpmbuild --with check is used

* Fri May 24 2002 Rex Dieter <rdieter@unl.edu> 0.9-6
- rebuild for rh7.3 
- Requires: gc >= 6.1, gmp >= 4.0.1

* Thu Apr 04 2002 Rex Dieter <rdieter@unl.edu> 0.9-5
- nix emacs subpkg

* Thu Feb 21 2002 Rex Dieter <rdieter@math.unl.edu> 0.9-4
- explicit Requires: gc  (helps out apt)
- emacs subpkg: Remove site-lisp dir Requirement (for apt)

* Fri Feb 08 2002 Rex Dieter <rdieter@math.unl.edu> 0.9-3
- static patch to build real dynamic version (this worked in 0.9-1 ?)
- applnk entry

* Wed Jan 02 2002 Rex Dieter <rdieter@math.unl.edu> 0.9-2
- make subpkgs depend on %%version-%%release

* Wed Nov 21 2001 Rex Dieter <rdieter@math.unl.edu> 0.9-1
- specfile cosmetics 
- (at least) pretend to be relocatable, though it
  %%post scripts don't seem to like it.

* Thu Nov 1 2001 Rex Dieter <rdieter@math.unl.edu> 0.9-0
- first try: 0.9

* Fri Aug 3 2001 Rex Dieter <rdieter@math.unl.edu> 0.8.99-10
- gmp was optimizing for the build host(i686), 
  not the target(i386), so it was dying mysteriously
  on any pre-i686 machine.
- Group: Applications/Engineering

* Fri Jun 1 2001 Rex Dieter <rdieter@math.unl.edu> 0.8.99-6
- use prefix /usr (instead of /usr/local)
- make -emacs subpackage for emacs mode files
- use more rpm macros: __rm, __make, __install, __gzip
- tag more %doc files
- make -emacs subpkg

* Tue May 29 2001 Rex Dieter <rdieter@math.unl.edu> 0.8.99-5
- make -doc subpkg.
- use rpm macros: _prefix, _libdir instead of hand
  hardcoded /usr/local/lib
- undo dumped binary (library and kernel upgrades break
  it, so let's not do it by default).

* Thu Apr  4 2001 Rex Dieter <rdieter@math.unl.edu>, 0.8.99-3
- Skip lex.m2 test  Why?
  1.  Dan apparently skips it, so why can't we? (-:
  2.  Usually dies with cpu time limit exceeded error anyway. 
  Now all platforms (waiting on ppc) pass all regression tests.

* Fri Jan 26 2001 Rex Dieter <rdieter@math.unl.edu>, 0.8.99-2
- attempt a true build from REAL source code. 
- include Macaulay2-doc.
- RH6 target built and passed all tests
- RH7 target built but did not pass all tests.

* Wed Jan 24 2001 Rex Dieter <rdieter@math.unl.edu>, 0.8.99-1
- update to 0.8.99

* Mon Jan 22 2001 Rex Dieter <rdieter@math.unl.edu>, 0.8.60-3
- %postun : fix errors
- %post : make ./setup step silent
- fixup uninstall script

* Mon Nov 27 2000 Rex Dieter <rdieter@math.unl.edu>, 0.8.60-0
- First attempt at rpm.

